import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { GltUserTicket, GltUserTicketParam } from './model';

/**
 * 分页查询我的水票
 */
export async function pageGltUserTicket(params: GltUserTicketParam) {
  const res = await request.get<ApiResult<PageResult<GltUserTicket>>>(
    '/glt/glt-user-ticket/page',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询我的水票列表
 */
export async function listGltUserTicket(params?: GltUserTicketParam) {
  const res = await request.get<ApiResult<GltUserTicket[]>>(
    '/glt/glt-user-ticket',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加我的水票
 */
export async function addGltUserTicket(data: GltUserTicket) {
  const res = await request.post<ApiResult<unknown>>(
    '/glt/glt-user-ticket',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改我的水票
 */
export async function updateGltUserTicket(data: GltUserTicket) {
  const res = await request.put<ApiResult<unknown>>(
    '/glt/glt-user-ticket',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除我的水票
 */
export async function removeGltUserTicket(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/glt/glt-user-ticket/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除我的水票
 */
export async function removeBatchGltUserTicket(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/glt/glt-user-ticket/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询我的水票
 */
export async function getGltUserTicket(id: number) {
  const res = await request.get<ApiResult<GltUserTicket>>(
    '/glt/glt-user-ticket/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取我的水票总数
 */
export async function getMyGltUserTicketTotal() {
  const res = await request.get<ApiResult<number | { total?: number }>>(
    '/glt/glt-user-ticket/my-total'
  );
  if (res.code === 0) {
    const data: any = res.data;
    if (typeof data === 'number') return data;
    if (data && typeof data.total === 'number') return data.total;
    return 0;
  }
  return Promise.reject(new Error(res.message));
}
